//+------------------------------------------------------------------+
//|                                                 MyIchimokuEA.mq4 |
//|                            Copyright 2013-2014, Brian M. Lillard |
//|                                                     www.mql4.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013-2014, Brian M. Lillard"
#property link      "www.mql4.com"
#include <stderror.mqh>
#define NA 0
#define BUY 1
#define SELL 2
//+------------------------------------------------------------------+
extern   string BrokerVariableSettings="*** Broker Variable Settings ***";
extern      int MagicNumber = 654231; int newMagic;
extern     bool _ecn = true;
extern     bool _hedging = false; 
extern   double MaximumSpread = 7;
extern      int _slippage=5;
extern      int _retries=6;
         string _symbol;
            int _signal = NA;
extern   string MoneyManagementSettings="*** Money Management Settings ***";
extern   double PercentageOfBalance = 0.00;
extern     bool MinLotAfterLoss = false;
extern   string OrderSpecificSettings="*** Order Specific Settings ***";
extern   double LotSize = 0.01;
extern      int OrderQuantity = 1;
extern      int MaxOrdersAllowedPerDay = -1;
extern     bool UpdateSLTP = false;
extern   double StopLoss = 35;
extern   double TakeProfit = 150;
extern     bool UseTrailingStop = true;
extern      int TrailingStart = 35;
extern      int TrailingStop = -35;
extern   string TimeFilters="*** Time Filters ***";
extern   double GoodForTheDay_Profit = 0.0;
extern   double GoodForTheDay_Pips = 0.0;
         string _comment;
extern   string TimeFilterSettings = "Asia 1-10, Europe 7-16,US 14-23";
extern      int GMTShift = 0;
extern      int BeginHour = 0;
extern      int BeginMinute = 0;
extern      int EndHour = 24;
extern      int EndMinute = 0;
extern     bool CloseAllAfterEnd=false;
extern   string MoreEASettings="*** Miscelaneous options for your EA ***";
//extern     bool EA_Multimeter = true;
extern     bool EA_Comment = false;
extern     bool AudibleAlerts = false;
extern    color _buyarrow = Green;
extern    color _sellarrow = Red;
extern     bool _debug=true;
extern     bool _testmagic=false;
extern   string IndicatorSettings="*** Set the specific indicator settings ***";
extern      int _timeframe = 0; int newTimeframe;
//+------------------------------------------------------------------+
//
extern      int TenkanSen_Period=9;
extern      int KijunSen_Period=26;
extern      int SenkouSpanB_Period=52;
extern      int BarShift=1;
//
//+------------------------------------------------------------------+
static datetime Bar1Time;
double SymPt,SymSprd,_digits;
bool OpenOrdersFound;
int BuysOpen, SellsOpen;
double BuysOpenProfit, SellsOpenProfit;
int _err;
double _buyspips,_sellspips;
//+------------------------------------------------------------------+
//| expert indicator signals                                         |
//| http://docs.mql4.com/indicators/iIchimoku                        |
//+------------------------------------------------------------------+
int IndicatorSignal()
   {
   RefreshRates();
   //past
   double HighAtChinkou=iHigh(NULL,newTimeframe,BarShift+26);
   double LowAtChinkou=iLow(NULL,newTimeframe,BarShift+26);
   double CloseAtChinkou=iClose(NULL,newTimeframe,BarShift+26);
   double Chinkou_Span=iIchimoku(NULL,newTimeframe,TenkanSen_Period,KijunSen_Period,SenkouSpanB_Period,MODE_CHINKOUSPAN,BarShift+26);
   double PastSenkou_Span_A=iIchimoku(NULL,newTimeframe,TenkanSen_Period,KijunSen_Period,SenkouSpanB_Period,MODE_SENKOUSPANA,BarShift+26);
   double PastSenkou_Span_B=iIchimoku(NULL,newTimeframe,TenkanSen_Period,KijunSen_Period,SenkouSpanB_Period,MODE_SENKOUSPANB,BarShift+26);
   //present
   double HighAtPresent=iHigh(NULL,newTimeframe,BarShift);
   double LowAtPresent=iLow(NULL,newTimeframe,BarShift);
   double CloseAtPresent=iClose(NULL,newTimeframe,BarShift);
   double Senkou_Span_A=iIchimoku(NULL,newTimeframe,TenkanSen_Period,KijunSen_Period,SenkouSpanB_Period,MODE_SENKOUSPANA,BarShift);
   double Senkou_Span_B=iIchimoku(NULL,newTimeframe,TenkanSen_Period,KijunSen_Period,SenkouSpanB_Period,MODE_SENKOUSPANB,BarShift);
   double Tenkan_Sen=iIchimoku(NULL,newTimeframe,TenkanSen_Period,KijunSen_Period,SenkouSpanB_Period,MODE_TENKANSEN,BarShift);
   double Kijun_Sen=iIchimoku(NULL,newTimeframe,TenkanSen_Period,KijunSen_Period,SenkouSpanB_Period,MODE_KIJUNSEN,BarShift);
   //double CloseAtPresent_1=iClose(NULL,_timeframe,BarShift+1);
   //double Senkou_Span_A_1=iIchimoku(NULL,_timeframe,TenkanSen_Period,KijunSen_Period,SenkouSpanB_Period,MODE_SENKOUSPANA,BarShift+1);
   //double Senkou_Span_B_1=iIchimoku(NULL,_timeframe,TenkanSen_Period,KijunSen_Period,SenkouSpanB_Period,MODE_SENKOUSPANB,BarShift+1);
   //future
   double FutureSenkou_Span_A=iIchimoku(NULL,newTimeframe,TenkanSen_Period,KijunSen_Period,SenkouSpanB_Period,MODE_SENKOUSPANA,BarShift-26);
   double FutureSenkou_Span_B=iIchimoku(NULL,newTimeframe,TenkanSen_Period,KijunSen_Period,SenkouSpanB_Period,MODE_SENKOUSPANB,BarShift-26);
//----
   TextLabel("Multi_1", "", 12, "Wingdings", Lime, 10, 23, 1);
   TextLabel("Multi_2", "", 12, "Wingdings", Lime, 10, 41, 1);
   TextLabel("Multi_3", "", 12, "Wingdings", Lime, 10, 59, 1);
   TextLabel("Multi_4", "", 12, "Wingdings", Lime, 10, 77, 1);
   TextLabel("Multi_5", "", 12, "Wingdings", Lime, 10, 95, 1);
   TextLabel("Multi_6", "Waiting For Signals", 12, "Times New Roman", Lime, 16, 118, 1);
   TextLabel("Multi_7", "Chinkou Span Vs. Candle:", 8, "Arial", Lime, 30, 23, 1);
   TextLabel("Multi_8", "Chinkou Span Vs. Kumo:", 8, "Arial", Lime, 30, 41, 1);
   TextLabel("Multi_9", "Kumo Vs.Candle:", 8, "Arial", Lime, 30, 59, 1);
   TextLabel("Multi_10", "Tenkan Sen Vs. Kijun Sen:", 8, "Arial", Lime, 30, 77, 1);
   TextLabel("Multi_11", "Senkou A Vs. Senkou B:", 8, "Arial", Lime, 30, 95, 1);
//----
   int PastSignal=0;//Chinkou Span Vs. Candle and Chinkou Span Vs. Kumo
   //--buy
   if(Chinkou_Span>HighAtChinkou&&Chinkou_Span>CloseAtChinkou)
      {
      if(Chinkou_Span>PastSenkou_Span_A&&PastSenkou_Span_A>PastSenkou_Span_B)
         {
         PastSignal=BUY;
         }
      }
   if(Chinkou_Span>HighAtChinkou&&Chinkou_Span>CloseAtChinkou){TextLabel("Multi_1", "", 12, "Wingdings", Lime, 10, 23, 1);}
   if(Chinkou_Span>PastSenkou_Span_A&&PastSenkou_Span_A>PastSenkou_Span_B){TextLabel("Multi_2", "", 12, "Wingdings", Lime, 10, 41, 1);}
   //--sell
   if(Chinkou_Span<LowAtChinkou&&Chinkou_Span<CloseAtChinkou)
      {
      if(Chinkou_Span<PastSenkou_Span_B&&PastSenkou_Span_A<PastSenkou_Span_B)
         {
         PastSignal=SELL;
         }
      }
   if(Chinkou_Span<LowAtChinkou&&Chinkou_Span<CloseAtChinkou){TextLabel("Multi_1", "", 12, "Wingdings", Lime, 10, 23, 1);}
   if(Chinkou_Span<PastSenkou_Span_B&&PastSenkou_Span_A<PastSenkou_Span_B){TextLabel("Multi_2", "", 12, "Wingdings", Lime, 10, 41, 1);}      
   //--na
   if(Chinkou_Span<HighAtChinkou&&Chinkou_Span>LowAtChinkou){TextLabel("Multi_1", "", 12, "Wingdings", Lime, 10, 23, 1); PastSignal=NA;}
   if(Chinkou_Span<PastSenkou_Span_A&&Chinkou_Span>PastSenkou_Span_B||
      Chinkou_Span>PastSenkou_Span_A&&Chinkou_Span<PastSenkou_Span_B){TextLabel("Multi_2", "", 12, "Wingdings", Lime, 10, 41, 1); PastSignal=NA;}
//----
   int PresentSignal=0;//Kumo Vs. Candle and Tenkan Sen Vs. Kijun Sen
   //--buy
   if(Senkou_Span_A>Senkou_Span_B&&CloseAtPresent>Senkou_Span_A)
      {
      if(LowAtPresent>Senkou_Span_A&&Tenkan_Sen>Kijun_Sen)
         {
         PresentSignal=BUY;
         }
      }
   if(Senkou_Span_A>Senkou_Span_B&&CloseAtPresent>Senkou_Span_A){TextLabel("Multi_3", "", 12, "Wingdings", Lime, 10, 59, 1);}
   if(LowAtPresent>Senkou_Span_A&&Tenkan_Sen>Kijun_Sen){TextLabel("Multi_4", "", 12, "Wingdings", Lime, 10, 77, 1);}
   //--sell
   if(Senkou_Span_A<Senkou_Span_B&&CloseAtPresent>Senkou_Span_B)
      {
      if(HighAtPresent<Senkou_Span_B&&Tenkan_Sen<Kijun_Sen)
         {
         PresentSignal=SELL;
         }
      }
   if(Senkou_Span_A<Senkou_Span_B&&CloseAtPresent>Senkou_Span_B){TextLabel("Multi_3", "", 12, "Wingdings", Lime, 10, 59, 1);}
   if(HighAtPresent<Senkou_Span_B&&Tenkan_Sen<Kijun_Sen){TextLabel("Multi_4", "", 12, "Wingdings", Lime, 10, 77, 1);}
   //--na
   if(Senkou_Span_A<HighAtPresent&&Senkou_Span_A>LowAtPresent||
      Senkou_Span_A>HighAtPresent&&Senkou_Span_B<LowAtPresent||
      Senkou_Span_A>HighAtPresent&&Senkou_Span_B>LowAtPresent||
      Senkou_Span_A>HighAtPresent&&Senkou_Span_B<LowAtPresent){TextLabel("Multi_3", "", 12, "Wingdings", Lime, 10, 59, 1); PresentSignal=NA;}
   if(Tenkan_Sen==Kijun_Sen){TextLabel("Multi_4", "", 12, "Wingdings", Lime, 10, 77, 1); PresentSignal=NA;}
//----
   int FutureSignal=0;//Senkou A Vs. Senkou B
   //--buy
   if(FutureSenkou_Span_A>FutureSenkou_Span_B){TextLabel("Multi_5", "", 12, "Wingdings", Lime, 10, 95, 1); FutureSignal=BUY;}
   //--sell
   if(FutureSenkou_Span_A<FutureSenkou_Span_B){TextLabel("Multi_5", "", 12, "Wingdings", Lime, 10, 95, 1); FutureSignal=SELL;}
   //--na
   if(FutureSenkou_Span_A==FutureSenkou_Span_B){TextLabel("Multi_5", "", 12, "Wingdings", Lime, 10, 95, 1); FutureSignal=NA;}
//----
   _signal=NA;//Signal For Expert Advisor
   //--buy
   if(FutureSignal==BUY&&PresentSignal==BUY&&PastSignal==BUY){TextLabel("Multi_6", "Bullish Signal", 12, "Times New Roman", Lime, 16, 118, 1); _signal=BUY;}
   //--sell
   if(FutureSignal==SELL&&PresentSignal==SELL&&PastSignal==SELL){TextLabel("Multi_6", "Bearish Signal", 12, "Times New Roman", Lime, 16, 118, 1); _signal=SELL;}
   //--na
   if(FutureSignal==NA||PresentSignal==NA||PastSignal==NA){TextLabel("Multi_6", "Price is Consolidated", 12, "Times New Roman", Lime, 16, 118, 1); _signal=NA;}
//----
   }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int init()
   {
   Bar1Time=Time[1];
   _symbol=Symbol(); 
   if(_testmagic==true){newMagic=TestMagic();}else{newMagic=MagicNumber;}
   if(_timeframe==0){newTimeframe=Period();}else{newTimeframe=_timeframe;}
   IndicatorSignal();
   OrdersTotalInfo(); 
   if(EA_Comment){DisplayEAComment();}else{Comment("");}
   _comment=_symbol+"_"+newTimeframe+"_"+newMagic;
   if(UpdateSLTP){UpdateSLTP();} 
   return(0);
   }
//+------------------------------------------------------------------+
int start()
   {
//-- ticks
   IndicatorSignal(); 
   OrdersTotalInfo(); 
   if(EA_Comment){DisplayEAComment();}else{Comment("");}
//-- bars
   if(!NewBar()){return(0);}
   if(GoodForTheDay_Profit>0 && GoodForTheDayProfit()){CloseOrder(BUY);CloseOrder(SELL); return(0);}   
   if(GoodForTheDay_Pips>0 && GoodForTheDayPips()){CloseOrder(BUY);CloseOrder(SELL); return(0);}  
   if(UseTrailingStop){TrailingStop();}
   if(TodaysOrders()>=MaxOrdersAllowedPerDay && MaxOrdersAllowedPerDay!=-1){return(0);}      
   if(!TradingTime(BeginHour,EndHour,BeginMinute,EndMinute,GMTShift)){if(CloseAllAfterEnd){CloseOrder(BUY);CloseOrder(SELL);} return(0);}   


   
   if(_signal!=NA){}
   if(_signal==SELL && SellsOpen==0){if(!_hedging){CloseOrder(BUY);}OpenOrder(SELL);}
   if(_signal==BUY && BuysOpen==0){if(!_hedging){CloseOrder(SELL);}OpenOrder(BUY);}
   return(0);
   }
//+------------------------------------------------------------------+
int deinit()
   {
   Comment("");
   for(int LabelCNT = 1; LabelCNT <=11; LabelCNT++)
      {
      ObjectDelete("Multi_"+LabelCNT);
      }
   return(0);
   }  
//+------------------------------------------------------------------+
//TradingTime(BeginHour,EndHour,BeginMinute,EndMinute,GMTShift);
bool TradingTime(int starthour,int endhour,int startminute,int endminute,int shift)
   {
   if(BeginHour==0 && EndHour==24){return(true);}
   int starttime=starthour*60+startminute;
   int endtime=endhour*60+endminute;   
   int nowtime=(Hour()+shift)*60+Minute();
   if(nowtime<0){nowtime+=1440;}
   if(nowtime>=1440){nowtime-=1440;}
   if(starttime<=endtime)
      {
      if((nowtime<starttime)||(nowtime>=endtime))
         {
         if(EA_Comment){Comment("Not trading at this time.");}
         if(_debug){Print("TradingTime: Not trading at this time.");}
         return(false);
         }
      }
   return(true);
   }
//+------------------------------------------------------------------+
//TodaysOrders();
int TodaysOrders()
   {
   int TotalOrders=0;
   for(int i=OrdersTotal()-1; i>=0; i--)
      {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(TimeDayOfYear(OrderOpenTime())==TimeDayOfYear(TimeCurrent()))
         {
         TotalOrders+=1;
         }
      }
   for(i=OrdersHistoryTotal()-1; i>=0; i--)
      {
      OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
      if(TimeDayOfYear(OrderOpenTime())==TimeDayOfYear(TimeCurrent()))
         {
         TotalOrders+=1;
         }
      }
   return(TotalOrders);
   }
//+------------------------------------------------------------------+
//GoodForTheDayProfit(GoodForTheDay_Profit);
bool GoodForTheDayProfit()
   {
   double _profit=0.0;
   double _loss=0.0;
   for(int GFTDP=OrdersTotal()-1; GFTDP>=0; GFTDP--)
      {
      OrderSelect(GFTDP,SELECT_BY_POS,MODE_TRADES);
      if(TimeDayOfYear(OrderOpenTime())==TimeDayOfYear(TimeCurrent()) &&
         OrderSymbol()==_symbol && OrderMagicNumber()==newMagic && OrderComment()==_comment)
         {
         if(OrderProfit()+OrderCommission()+OrderSwap()>0)
            {_profit+=OrderProfit()+OrderCommission()+OrderSwap();}
         if(OrderProfit()+OrderCommission()+OrderSwap()<0)
            {_loss+=OrderProfit()+OrderCommission()+OrderSwap();}
         }
      }
   for(GFTDP=OrdersHistoryTotal()-1; GFTDP>=0; GFTDP--)
      {
      OrderSelect(GFTDP,SELECT_BY_POS,MODE_HISTORY);
      if(TimeDayOfYear(OrderOpenTime())==TimeDayOfYear(TimeCurrent()) &&
         OrderSymbol()==_symbol && OrderMagicNumber()==newMagic && OrderComment()==_comment)
         {
         if(OrderProfit()+OrderCommission()+OrderSwap()>0)
            {_profit+=OrderProfit()+OrderCommission()+OrderSwap();}
         if(OrderProfit()+OrderCommission()+OrderSwap()<0)
            {_loss+=OrderProfit()+OrderCommission()+OrderSwap();}
         }
      }
   if(_profit+_loss>=GoodForTheDay_Profit)
      {
      if(_debug && GoodForTheDay_Profit>0){Print("GoodForTheDayProfit: Done Trading For The Day.");}
      return(true);
      }
   else
      {
      if(_debug && GoodForTheDay_Profit>0){Print("GoodForTheDayProfit: Daily Profit/Loss: "+DoubleToStr(_profit+_loss,2)+", of "+DoubleToStr(GoodForTheDay_Profit,2));}
      return(false);
      }
   }
//+------------------------------------------------------------------+
//GoodForTheDayPips();
bool GoodForTheDayPips() 
   {
   _buyspips=0;
   _sellspips=0;
   int _symM;
   //point and spread
   _digits=MarketInfo(_symbol,MODE_DIGITS);
   if(_digits==3){_symM=100;}
   if(_digits==5){_symM=10000;}
   for(int GFTDPips=OrdersTotal()-1; GFTDPips>=0; GFTDPips--)
      {
      OrderSelect(GFTDPips,SELECT_BY_POS,MODE_TRADES);
         {
         if(TimeDayOfYear(OrderOpenTime())==TimeDayOfYear(TimeCurrent()) &&
            OrderSymbol()==_symbol && OrderMagicNumber()==newMagic && OrderComment()==_comment)
            {
            if(OrderType()==OP_BUY){_buyspips+=OrderClosePrice()-OrderOpenPrice();}
            if(OrderType()==OP_SELL){_sellspips+=OrderOpenPrice()-OrderClosePrice();}
            }
         }
      }
   for(GFTDPips=OrdersHistoryTotal()-1; GFTDPips>=0; GFTDPips--)
      {
      OrderSelect(GFTDPips,SELECT_BY_POS,MODE_HISTORY);
         {
         if(TimeDayOfYear(OrderOpenTime())==TimeDayOfYear(TimeCurrent()) &&
            OrderSymbol()==_symbol && OrderMagicNumber()==newMagic && OrderComment()==_comment)
            {
            if(OrderType()==OP_BUY){_buyspips+=OrderClosePrice()-OrderOpenPrice();}
            if(OrderType()==OP_SELL){_sellspips+=OrderOpenPrice()-OrderClosePrice();}
            }
         }
      }
   if(_buyspips+_sellspips*_symM>=GoodForTheDay_Pips)
      {
      if(_debug && GoodForTheDay_Pips>0){Print("GoodForTheDayPips: Done Trading For The Day.");} 
      return(true);
      }
   else
      {
      if(_debug && GoodForTheDay_Pips>0){Print("GoodForTheDayPips: Daily Pips Profit/Loss: "+DoubleToStr(_buyspips+_sellspips*_symM,1)+" of "+DoubleToStr(GoodForTheDay_Pips,1));}
      return(false);
      }
   }
//+------------------------------------------------------------------+
void UpdateSLTP()
   {
   //point and spread
   _digits=MarketInfo(_symbol,MODE_DIGITS);
   if(_digits==3){SymPt=0.01; SymSprd=(Ask-Bid)*100;}
   if(_digits==5){SymPt=0.0001; SymSprd=(Ask-Bid)*10000;}
   
   for(int UpdateOpenTotal=OrdersTotal()-1; UpdateOpenTotal>=0; UpdateOpenTotal--)
      {
      if(OrderSelect(UpdateOpenTotal,SELECT_BY_POS,MODE_TRADES)==true)
         {
         if(OrderSymbol()==Symbol() && 
            OrderMagicNumber()==newMagic &&
            OrderComment()==_comment)
            {
            if(OrderType()==OP_BUY)
               {//newSL=Bid-StopLoss*SymPt; newTP=Bid+TakeProfit*SymPt;
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-StopLoss*SymPt,OrderOpenPrice()+TakeProfit*SymPt,0,_buyarrow);
               }
            if(OrderType()==OP_SELL)
               {//newSL=Ask+StopLoss*SymPt; newTP=Ask-TakeProfit*SymPt;
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+StopLoss*SymPt,OrderOpenPrice()-TakeProfit*SymPt,0,_sellarrow);
               }
            }
         }
      else{Print("GetOrders: Could not select any trades from the trade pool.");}
      }
   }
//+------------------------------------------------------------------+
//OrdersTotalInfo();
void OrdersTotalInfo()
   {
   SellsOpen=0; BuysOpen=0;
   BuysOpenProfit=0; SellsOpenProfit=0;
   for(int OrdersOpenTotal=OrdersTotal()-1; OrdersOpenTotal>=0; OrdersOpenTotal--)
      {
      if(OrderSelect(OrdersOpenTotal,SELECT_BY_POS,MODE_TRADES)==true)
         {
         if(OrderSymbol()==Symbol() && 
            OrderMagicNumber()==newMagic &&
            //OrderComment()==_comment &&
            OrderType()==OP_SELL){SellsOpen++;
            if(OrderProfit()+OrderCommission()+OrderSwap()>0){SellsOpenProfit+=OrderProfit()+OrderCommission()+OrderSwap();}}
         else
            {
            if(OrderSymbol()==Symbol() && 
               OrderMagicNumber()==newMagic &&
               //OrderComment()==_comment &&
               OrderType()==OP_BUY){BuysOpen++;
               if(OrderProfit()+OrderCommission()+OrderSwap()>0){BuysOpenProfit+=OrderProfit()+OrderCommission()+OrderSwap();}}
            }
         }
      else{Print("GetOrders: Could not select any trades from the trade pool.");}
      }
   OrdersOpenTotal=SellsOpen+BuysOpen;
   if(OrdersOpenTotal>0){OpenOrdersFound=true;}else{OpenOrdersFound=false;}
   }
//+------------------------------------------------------------------+
//DisplayEAComment();
int marqueCNT1=-1;
string marque;
void DisplayEAComment()
   {
   //point and spread
   if(_digits==3){SymPt=0.01; SymSprd=(Ask-Bid)*100;}
   if(_digits==5){SymPt=0.0001; SymSprd=(Ask-Bid)*10000;}
   marqueCNT1++;
   if(!OpenOrdersFound)
      {
      if(marqueCNT1==0){marque="=~=~=~=~=~=~";}
      if(marqueCNT1==1){marque="~=~=~=~=~=~=";marqueCNT1=-1;}      
      }
   else
      {
      if(marqueCNT1==0){marque="--//--//--//--//--//--//--/";}
      if(marqueCNT1==1){marque="-//--//--//--//--//--//--//";}
      if(marqueCNT1==2){marque="//--//--//--//--//--//--//-";}
      if(marqueCNT1==3){marque="/--//--//--//--//--//--//--";marqueCNT1=-1;}         
      }
   Comment(Symbol() + " Spread: " + DoubleToStr(SymSprd,1) + " pips"+
   "\n" + marque + " Sells Open: " + SellsOpen + 
   //"\n" + "UsedMargin: " + DoubleToStr(AccountMargin(),2) + " " + AccountCurrency() +  
   //"\n" + "FreeMargin: " + DoubleToStr(AccountFreeMargin(),2) + " " + AccountCurrency() +  
   "\n" + "UsedEquity: " + DoubleToStr(AccountEquity(),2) + " " + AccountCurrency() +
   "\n" + "EndBalance: " + DoubleToStr(AccountBalance(),2) + " " + AccountCurrency() +
   "\n" + marque + " Buys Open: " + BuysOpen
   );
   } 
//+------------------------------------------------------------------+
//NewBar();
bool NewBar(){if(Bar1Time!=Time[1]){Bar1Time=Time[1];return(true);}else{return(false);}}
//+------------------------------------------------------------------+
//Cmd(BUY);
int Cmd(int _CMD){if(_CMD==BUY){return(OP_BUY);} if(_CMD==SELL){return(OP_SELL);}}
//+------------------------------------------------------------------+
//Lots();
double Lot()
   {
   double _lot=LotSize;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
   if(PercentageOfBalance>0 || MinLotAfterLoss)
      {
      for(int i=orders-1; i>=0; i--)
        {
        if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false){Print("Error in selecting from history!"); break;}
        if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL){continue;}
        if(PercentageOfBalance>0 && OrderProfit()>0)
           {
           _lot=NormalizeDouble(AccountBalance()*PercentageOfBalance/10000,2); 
           return(NormalizeDouble(_lot,2));
           }
        if(MinLotAfterLoss && OrderProfit()<0)
           {
           _lot=NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),2); 
           return(NormalizeDouble(_lot,2));
           }
        //--
        }
      }
   if(PercentageOfBalance>0)
      {
      _lot=NormalizeDouble(AccountBalance()*PercentageOfBalance/10000,2);
      return(NormalizeDouble(_lot,2));
      }
   else{return(NormalizeDouble(_lot,2));}
   }
//+------------------------------------------------------------------+
//OpenOrder(BUY);
void OpenOrder(int CMD)
   {
   //point and spread
   _digits=MarketInfo(_symbol,MODE_DIGITS);
   if(_digits==3){SymPt=0.01; SymSprd=(Ask-Bid)*100;}
   if(_digits==5){SymPt=0.0001; SymSprd=(Ask-Bid)*10000;}
   //place orders with error check
   bool OpenOrderLoop=False;
   int OpenTryCount=0;
   for(int OpenCNT=0; OpenCNT<OrderQuantity; OpenCNT++)
      {
      while(!OpenOrderLoop)
         {
         //trading busy or spread too high
         while(IsTradeContextBusy() || SymSprd>MaximumSpread)
            {
            if(SymSprd>MaximumSpread)
               {
               if(_debug){Print("OpenOrder: Spread is "+SymSprd+", and the Max-Spread allowed is "+MaximumSpread+". Trying Again..");}
               }
            if(_debug){Print("OpenOrder: Trade Context Busy, Trying Again..");}
            Sleep(10);
            RefreshRates();
            }
         //place stp order
         int _ticket=-1;
         double newSL,newTP,_price;
         if(CMD==BUY)
            {
            newSL=Bid-StopLoss*SymPt; newTP=Bid+TakeProfit*SymPt; _price=Bid;
            if(_ecn){_ticket=OrderSend(_symbol,Cmd(CMD),Lot(),_price,_slippage,0.0,0.0,_comment,newMagic,0,_buyarrow);}
            else{_ticket=OrderSend(_symbol,Cmd(CMD),Lot(),_price,_slippage,newSL,newTP,_comment,newMagic,0,_buyarrow);}
            }
         if(CMD==SELL)
            {
            newSL=Ask+StopLoss*SymPt; newTP=Ask-TakeProfit*SymPt; _price=Ask;
            if(_ecn){_ticket=OrderSend(_symbol,Cmd(CMD),Lot(),_price,_slippage,0,0,_comment,newMagic,0,_sellarrow);}
            else{_ticket=OrderSend(_symbol,Cmd(CMD),Lot(),_price,_slippage,newSL,newTP,_comment,newMagic,0,_sellarrow);}
            }
         //error check and place ecn order
         _err=GetLastError(); if(!_ecn && _err==0){if(AudibleAlerts){PlaySound("alert.wav");} OpenOrderLoop=true;}       
         //--ecn modify
         if(_ecn && TakeProfit>0 && StopLoss>0 && _err==0)
            {
            if(OrderSelect(_ticket,SELECT_BY_TICKET))
               {
               if(CMD==BUY){OrderModify(_ticket,OrderOpenPrice(),newSL,newTP,0,_buyarrow);}
               if(CMD==SELL){OrderModify(_ticket,OrderOpenPrice(),newSL,newTP,0,_sellarrow);}
               if(AudibleAlerts){PlaySound("alert.wav");}
               OpenOrderLoop=true;
               }
            }
         //--no more retries, abort.
         if(_err>0)
            {
            Print("Open Error: " + ErrorDescription(_err) + ", Trying Again..");
            if(OpenTryCount>=_retries)
               {
               if(_debug){Print("Open Error: " + ErrorDescription(_err) + ". Retries exceeded, Could Not Open Order.");}
               OpenOrderLoop=true;
               }
            OpenTryCount++;          
            }
         }
      }
   }
//+------------------------------------------------------------------+
/*
//BreakEven()
void BreakEven()
   {
   int PipsProfitable=0;
   for(int BEvenCNT=OrdersTotal(); BEvenCNT>=0; BEvenCNT--)
      {
      if(OrderSelect(BEvenCNT,SELECT_BY_POS,MODE_TRADES)==True)
         {
         if(OrderSymbol()==Symbol() &&
            OrderMagicNumber()==MagicNumber &&
            OrderComment()==_comment)
            {
            if(OrderType()==OP_SELL)
               {
               
               }
            if(OrderType()==OP_BUY)
               {
               
               }
            //if(OrderProfit()>=
            }
         }
      }
   }
*/
//+------------------------------------------------------------------+
//TrailingStop();
void TrailingStop()
   {
   if(Digits==3){double TStopPt=TrailingStop*0.010; double TStartPt=TrailingStart*0.010;}
   if(Digits==5){TStopPt=TrailingStop*0.00010; TStartPt=TrailingStart*0.00010;}
   for(int TrailCNT=OrdersTotal(); TrailCNT>=0; TrailCNT--)
      {
      if(OrderSelect(TrailCNT,SELECT_BY_POS,MODE_TRADES)==True)
         {
         double newTS;
         if(OrderSymbol()==_symbol &&
            OrderMagicNumber()==newMagic &&
            OrderComment()==_comment &&
            OrderType()==OP_BUY)
            {
            if(TrailingStop<0){newTS=Ask-(TStartPt+MathAbs(TStopPt));}else{newTS=Ask-(TStartPt-TStopPt);}
            if(Ask>=OrderOpenPrice()+TStopPt && newTS>OrderStopLoss())
               {
               OrderModify(OrderTicket(),OrderOpenPrice(),newTS,OrderTakeProfit(),0,_buyarrow);
               if(AudibleAlerts){PlaySound("stops.wav");}
               }
            }
         if(OrderSymbol()==_symbol &&
            OrderMagicNumber()==newMagic &&
            OrderComment()==_comment &&
            OrderType()==OP_SELL)
            {
            if(TrailingStop<0){newTS=Bid+(TStartPt+MathAbs(TStopPt));}else{newTS=Bid+(TStartPt-TStopPt);}
            if(Bid<=OrderOpenPrice()-TStopPt && newTS<OrderStopLoss())
               {
               OrderModify(OrderTicket(),OrderOpenPrice(),newTS,OrderTakeProfit(),0,_sellarrow);
               if(AudibleAlerts){PlaySound("stops.wav");}
               }
            }
         }
      }
   }
//+------------------------------------------------------------------+
//CloseOrder(BUY);
void CloseOrder(int CMD)
   {
   //point and spread
   _digits=MarketInfo(_symbol,MODE_DIGITS);
   if(_digits==3){SymPt=0.01; SymSprd=(Ask-Bid)*100;}
   if(_digits==5){SymPt=0.0001; SymSprd=(Ask-Bid)*10000;}
   for(int CloseCNT=OrdersTotal()-1; CloseCNT>= 0; CloseCNT--)
      {
      if(OrderSelect(CloseCNT,SELECT_BY_POS,MODE_TRADES)==false){continue;}
      if(OrderSymbol()!=_symbol){continue;}
      if(OrderMagicNumber()!=newMagic){continue;}
      if(OrderComment()!=_comment){continue;}
      if(OrderType()!=Cmd(CMD)){continue;}
      bool CloseOrderLoop=False;
      int CloseTryCount=0;
      //trading busy
      while(!CloseOrderLoop)
         {
         while(IsTradeContextBusy())
            {if(_debug){Print("CloseOrder: Trade context busy, Trying Again..");Sleep(10);}}
         RefreshRates();
         //close orders with error check
         double SymAsk=NormalizeDouble(MarketInfo(_symbol,MODE_ASK),_digits);    
         double SymBid=NormalizeDouble(MarketInfo(_symbol,MODE_BID),_digits);
         if(Cmd(CMD)==OP_BUY){OrderClose(OrderTicket(),OrderLots(),SymBid,_slippage*SymPt,CLR_NONE );}
         else if(Cmd(CMD)==OP_SELL){OrderClose(OrderTicket(),OrderLots(),SymAsk,_slippage*SymPt,CLR_NONE);}
         //error check
         _err=GetLastError();
         if(_err==0){if(AudibleAlerts){PlaySound("news.wav");} CloseOrderLoop=true;}
         else{if(CloseTryCount>_retries){if(_debug){Print("Open Error: " + ErrorDescription(_err) + ". Retries exceeded, Could Not Open Order.");}}}        
         }
      }
   }
//+------------------------------------------------------------------+
//ErrorDescription(_err);
string ErrorDescription(int code)
   {
   string error;
   switch(code)
      {
      case 0:
      case 1:error="no error";break;
      case 2:error="common error";break;
      case 3:error="invalid trade parameters";break;
      case 4:error="trade server is busy";break;
      case 5:error="old version of the client terminal";break;
      case 6:error="no connection with trade server";break;
      case 7:error="not enough rights";break;
      case 8:error="too frequent requests";break;
      case 9:error="malfunctional trade operation";break;
      case 64:error="account disabled";break;
      case 65:error="invalid account";break;
      case 128:error="trade timeout";break;
      case 129:error="invalid price";break;
      case 130:error="invalid stops";break;
      case 131:error="invalid trade volume";break;
      case 132:error="market is closed";break;
      case 133:error="trade is disabled";break;
      case 134:error="not enough money";break;
      case 135:error="price changed";break;
      case 136:error="off quotes";break;
      case 137:error="broker is busy";break;
      case 138:error="requote";break;
      case 139:error="order is locked";break;
      case 140:error="long positions only allowed";break;
      case 141:error="too many requests";break;
      case 145:error="modification denied because order too close to market";break;
      case 146:error="trade context is busy";break;
      case 4000:error="no error";break;
      case 4001:error="wrong function pointer";break;
      case 4002:error="array index is out of range";break;
      case 4003:error="no memory for function call stack";break;
      case 4004:error="recursive stack overflow";break;
      case 4005:error="not enough stack for parameter";break;
      case 4006:error="no memory for parameter string";break;
      case 4007:error="no memory for temp string";break;
      case 4008:error="not initialized string";break;
      case 4009:error="not initialized string in array";break;
      case 4010:error="no memory for array\' string";break;
      case 4011:error="too long string";break;
      case 4012:error="remainder from zero divide";break;
      case 4013:error="zero divide";break;
      case 4014:error="unknown command";break;
      case 4015:error="wrong jump (never generated error)";break;
      case 4016:error="not initialized array";break;
      case 4017:error="dll calls are not allowed";break;
      case 4018:error="cannot load library";break;
      case 4019:error="cannot call function";break;
      case 4020:error="expert function calls are not allowed";break;
      case 4021:error="not enough memory for temp string returned from function";break;
      case 4022:error="system is busy (never generated error)";break;
      case 4050:error="invalid function parameters count";break;
      case 4051:error="invalid function parameter value";break;
      case 4052:error="string function internal error";break;
      case 4053:error="some array error";break;
      case 4054:error="incorrect series array using";break;
      case 4055:error="custom indicator error";break;
      case 4056:error="arrays are incompatible";break;
      case 4057:error="global variables processing error";break;
      case 4058:error="global variable not found";break;
      case 4059:error="function is not allowed in testing mode";break;
      case 4060:error="function is not confirmed";break;
      case 4061:error="send mail error";break;
      case 4062:error="string parameter expected";break;
      case 4063:error="integer parameter expected";break;
      case 4064:error="double parameter expected";break;
      case 4065:error="array as parameter expected";break;
      case 4066:error="requested history data in update state";break;
      case 4099:error="end of file";break;
      case 4100:error="some file error";break;
      case 4101:error="wrong file name";break;
      case 4102:error="too many opened files";break;
      case 4103:error="cannot open file";break;
      case 4104:error="incompatible access to a file";break;
      case 4105:error="no order selected";break;
      case 4106:error="unknown symbol";break;
      case 4107:error="invalid price parameter for trade function";break;
      case 4108:error="invalid ticket";break;
      case 4109:error="trade is not allowed";break;
      case 4110:error="longs are not allowed";break;
      case 4111:error="shorts are not allowed";break;
      case 4200:error="object is already exist";break;
      case 4201:error="unknown object property";break;
      case 4202:error="object is not exist";break;
      case 4203:error="unknown object type";break;
      case 4204:error="no object name";break;
      case 4205:error="object coordinates error";break;
      case 4206:error="no specified subwindow";break;
      default:error="unknown error";
      }
   return(error);
   }
//+------------------------------------------------------------------+




int TestMagic()
   {
   if(Symbol()=="EURUSD"){return(1+_timeframe);}
   if(Symbol()=="GBPUSD"){return(2+_timeframe);}
   if(Symbol()=="USDJPY"){return(3+_timeframe);}
   if(Symbol()=="USDCHF"){return(9+_timeframe);}
   if(Symbol()=="EURGBP"){return(7+_timeframe);}
   if(Symbol()=="EURCHF"){return(6+_timeframe);}
   if(Symbol()=="GBPCHF"){return(5+_timeframe);}
   if(Symbol()=="AUDUSD"){return(18+_timeframe);}
   if(Symbol()=="USDCAD"){return(8+_timeframe);}
   //--
   if(Symbol()=="CHFJPY"){return(4+_timeframe);}
   if(Symbol()=="XAGUSD"){return(100+_timeframe);}
   if(Symbol()=="XAUUSD"){return(200+_timeframe);}
   if(Symbol()=="EURJPY"){return(11+_timeframe);}
   if(Symbol()=="CHFJPY"){return(12+_timeframe);}
   if(Symbol()=="EURJPY"){return(13+_timeframe);}
   if(Symbol()=="GBPJPY"){return(14+_timeframe);}
   if(Symbol()=="AUDCAD"){return(15+_timeframe);}
   if(Symbol()=="AUDNZD"){return(16+_timeframe);}
   if(Symbol()=="NZDCAD"){return(19+_timeframe);}
   if(Symbol()=="GBPUSD"){return(2+_timeframe);}
   }



/*

//TextLabel("indi1","Sell",15,"Arial",Lime,false,250,250,1);
void TextLabel(string tlName,string fText,int fSize,string fName,color fColor,bool fBack,int lXcor,int lYcor,int Corner)
   {
   if(ObjectFind(tlName)==-1){ObjectCreate(tlName,OBJ_LABEL,0,0,0);}
   ObjectSetText(tlName,fText,fName,fSize,fColor);
   ObjectSet(tlName,OBJPROP_BACK,fBack);
   ObjectSet(tlName,OBJPROP_CORNER,Corner);//Top-left=0,Top-right=1,Bottom-left=2,Bottom-right=3
   ObjectSet(tlName,OBJPROP_XDISTANCE,lXcor);
   ObjectSet(tlName,OBJPROP_YDISTANCE,lYcor);
   }

*/



//TextLabel("signal", "SELL", 16, "Arial Black", Red, 45, 75, 1);
void TextLabel(string Name, string FontText, int FontSize, string FontName, 
                 color FontsColor, int xDis, int yDis, int WhatCorner)
   {
   if(ObjectFind(Name)==-1){ObjectCreate(Name,OBJ_LABEL,0,0,0);}
   //ObjectCreate(Name, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Name, FontText, FontSize, FontName, FontsColor);
   ObjectSet(Name, OBJPROP_CORNER, WhatCorner); //Upper left=0, Upper right=1, Lower left=2, Lower right=3
   ObjectSet(Name, OBJPROP_XDISTANCE, xDis);
   ObjectSet(Name, OBJPROP_YDISTANCE, yDis);
   
   }

























